\name{setup.smart}
\alias{setup.smart}
\title{
Smart prediction setup
}
\description{
Sets up smart prediction in one of two modes: "write" and "read".
}
\usage{
setup.smart(mode.arg, smart.prediction=NULL, max.smart=30)
}
\arguments{
\item{mode.arg}{
\code{mode.arg} must be "write" or "read".
If in "read" mode then smart.prediction must be assigned
the data structure \code{.smart.prediction} that was created
while fitting. This is stored in \code{object$smart.prediction}
where \code{object} is the name of the fitted object.
}
\item{max.smart}{
\code{max.smart} is the initial length of the list \code{.smart.prediction}.
It is not important because \code{.smart.prediction} is made larger if
needed.
}}
\value{
nothing is returned.
}
\section{Side Effects}{
In "write" mode
\code{.smart.prediction} in
the workspace (\R) or frame 1 (S-PLUS)
is assigned an empty list with max.smart components.
In "read" mode
\code{.smart.prediction} in
the workspace (\R) or frame 1 (S-PLUS)
is assigned \code{smart.prediction}.
In both cases, 
\code{.smart.prediction.counter} in frame 1 (S-PLUS) or
the workspace (\R) is assigned the value 0, and
\code{.smart.prediction.mode} and \code{.max.smart} are written to
the workspace (\R) or frame 1 (S-PLUS) too.
}
\details{
This function is only required by programmers writing a modelling
function such as \code{lm} and \code{glm}, or a prediction functions
of such,
e.g., \code{predict.lm}.
\code{setup.smart} operates by mimicking the operations of a
first-in first-out stack (better known as a queue).
}
\seealso{
lm, predict.lm 
}
\examples{
\dontrun{# Uncomment and put in lm
setup.smart("write")
}

\dontrun{# Uncomment and put in predict.lm
 setup.smart("read", smart.prediction=object$smart)
}


}
%\keyword{smart}
\keyword{models}
\keyword{regression}
\keyword{programming}

% Converted by Sd2Rd version 1.10.
